package cn.iocoder.yudao.module.order.convert.orderFeeApplication;

import java.util.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import org.mapstruct.Mapper;
import org.mapstruct.factory.Mappers;
import cn.iocoder.yudao.module.order.vo.orderFeeApplication.*;
import cn.iocoder.yudao.module.order.dal.dataobject.orderFeeApplication.OrderFeeApplicationDO;

/**
 * 订单费用申请 Convert
 * @author 系统管理员
 */
@Mapper
public interface OrderFeeApplicationConvert {
    /*****转换MapStruct*****/
    OrderFeeApplicationConvert INSTANCE = Mappers.getMapper(OrderFeeApplicationConvert.class);

    /***
     * 创建VO转实体
     * @param bean
     * @return
     */
    OrderFeeApplicationDO convert(OrderFeeApplicationCreateReqVO bean);

    /***
     * 修改VO转实体
     * @param bean
     * @return
     */
    OrderFeeApplicationDO convert(OrderFeeApplicationUpdateReqVO bean);

    /***
     * 实体转返回VO
     * @param bean
     * @return
    */
    OrderFeeApplicationBackVO convert(OrderFeeApplicationDO bean);

    /***
     * 实体列表转返回VO列表
     * @param list
     * @return
     */
    List<OrderFeeApplicationBackVO> convertList(List<OrderFeeApplicationDO> list);

    /***
     * 实体分页转返回分页
     * @param page
     * @return
     */
    PageResult<OrderFeeApplicationBackVO> convertPage(PageResult<OrderFeeApplicationDO> page);
}
