package cn.iocoder.yudao.module.order.vo.orderWarehouseAdjust;

import cn.iocoder.yudao.module.order.vo.orderLocation.OrderLocationCreateReqVO;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import javax.validation.constraints.NotNull;
import java.util.Date;
import java.util.List;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

/**
* 调仓记录 Base VO，提供给添加、修改、详细的子 VO 使用
* 如果子 VO 存在差异的字段，请不要添加到这里，影响 Swagger 文档生成
*/
@Data
public class OrderWarehouseAdjustArrivedVO {


    @ApiModelProperty(value = "主键ID", required = true)
    @NotNull(message = "主键ID不能为空")
    private Long id;

    @ApiModelProperty(value = "到仓日期")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @NotNull(message = "到仓日期不能为空")
    private Date arrivalDate;

    @ApiModelProperty(value = "备注")
    private String arrivalRemark;


    @ApiModelProperty(value = "到仓影像")
    private List<String> urls;



    @ApiModelProperty(value = "转异-异常类型 eg:1,2,3")
    private String manualExceptionType;

    @ApiModelProperty(value = "转异-描述中文")
    private String descZh;

    @ApiModelProperty(value = "转异-描述英文")
    private String descEn;

    @ApiModelProperty(value = "转异-描述法文")
    private String descFr;

    @ApiModelProperty(value = "异常附件")
    private List<String> exceptionUrls;


    //储位
    @ApiModelProperty(value = "储位列表")
    private List<OrderLocationCreateReqVO> orderLocationCreateReqVOList;



}
